#include <iostream>
#include "Contact.hpp"
#include <list>
#include <algorithm>

using namespace std;
using namespace reseau;

// list<Personne>::iterator it = find(lesContacts.begin(), lesContacts.end(), personne)

Contact::Contact(const Personne& Proprietaire): Proprietaire{Proprietaire} {
	cout << "Contact créé " << Proprietaire << "\n";
}

bool Contact::ajouterContact(const Personne& unContact){
	if(lesContacts.empty()){
		cout << "Contact ajouté " << unContact <<"\n";
		lesContacts.push_back(&unContact);
		return true;
	}
	if(unContact==Proprietaire)
	{
		cout << "Erreur : Contact déjà existant (Proprietaire)\n";
		return false;	
	}
	list<const Personne*>::iterator it = find(lesContacts.begin(), lesContacts.end(), &unContact);
	if(it!=lesContacts.end()){
		cout << "Erreur : Personne déjà dans vos contacts : " << unContact << "\n";
		return false;
	}
	else {
		cout << "Contact ajouté " << unContact <<"\n";
		lesContacts.push_back(&unContact);
		return true;
	}
	return true;
}

bool Contact::rechercher(const Personne& unContact){
	list<const Personne*>::iterator it = find(lesContacts.begin(), lesContacts.end(),&unContact);
	if(it != lesContacts.end())
	{
		cout << "trouvé : " << unContact << "\n";
		return true;
	}
	else 
	{
		cout << "pas trouvé\n";
		return false;
	}
	lesContacts.sort();
}

bool Contact::supprimerContact(const Personne& unContact){
	list<const Personne*>::iterator it = find(lesContacts.begin(), lesContacts.end(), &unContact);
	if(it!=lesContacts.end()){
		lesContacts.erase(it);
		cout << "Contact " << unContact << " supprimé\n";
		return true;
	}
	else {
		cout << "Erreur : le contact n'existe pas\n";
		return false;
	}
}


void Contact::envoyerMessage(std::string texte, Personne p){
	
}

// string recevoirMessage(std::string texte, Personne p)

ostream& reseau::operator<<(ostream& os, Personne p){
	return os << p.getNom() << " " << p.getPrenom() << " " << p.getNumTel();
}

bool reseau::operator==(reseau::Personne p1, reseau::Personne p2){
	if(p1.getNom()==p2.getNom()){
		if(p1.getPrenom()==p2.getPrenom()){
			if(p1.getNumTel()==p2.getNumTel())
				return true;
		}
	}
	return false;
}
